/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.email.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class EmailLayoutTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String bezeichnung;
    public java.lang.String getBezeichnung(){
      return bezeichnung;
    }

  public EmailLayoutTK(
java.lang.String bezeichnung
  ) {
    super();


      this.bezeichnung = bezeichnung;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((bezeichnung == null) ? 0 : bezeichnung.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof EmailLayoutTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        EmailLayoutTK other = (EmailLayoutTK) obj;

                if (bezeichnung == null) {
          if (other.bezeichnung != null) {
            return false;
          }
        } else if (!bezeichnung.equals(other.bezeichnung)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return EmailLayoutConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(EmailLayoutConstants.MESSAGE_KEY_ENTITY_EINZAHL, EmailLayoutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, bezeichnung));
        
        return result;
      }


            @Override
            public String toString() {
            return "EmailLayoutTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"bezeichnung="+bezeichnung
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(EmailLayoutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL) + "=" + bezeichnung
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends EmailLayout> java.util.Map<EmailLayoutTK, E> mappeEmailLayoutNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(EmailLayout::getEmailLayoutTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<EmailLayout, EmailLayoutTK> getEmailLayoutToTKFunction() {
                return EmailLayout::getEmailLayoutTK;
                }

}
